<?php
// Copyright (c) 2010, PRiSE. All Rights Reserved.
// Based on the icGPoA developed by RedIRIS.
//
// You may distribute under the terms of the GNU General Public License,
// as specified in the LICENSE file that was shipped with this distribution

// Constant for encrypt and decrypt data with openssl
define('PADDINGSIZE', 11);

function encrypt_private_key($in, $key, $key_bits = 0) {
// Get the byte size of data string 
    $inputSize = strlen($in);

    // Get details of the key
    $res = openssl_get_privatekey($key);
    if ($key_bits==0) {
        $key_details = openssl_pkey_get_details($res);
    }
    else {
        $key_details=array('bits' => $key_bits);
    }

    // Get the output block maximun size in Bytes
    $outputBlockSize = 	$key_details['bits']/8;

    // Total number of blocks
    $inputBlockSize = $outputBlockSize - PADDINGSIZE;
    $numBlocks = ceil($inputSize/$inputBlockSize);

    // Start to encrypt.
    $blockCount = 0;
    $cryptBuffer = array();

    while ($blockCount < $numBlocks) {
        $index = $blockCount * $inputBlockSize;
        $block = substr($in, $index, $inputBlockSize);
        openssl_private_encrypt($block, $crypttext, $key);
        $cryptBuffer[$blockCount] = $crypttext;
        $blockCount++;
    }
    // Now joint the array with the blocks string encripted
    $cryptData = join("", $cryptBuffer);

    $base64CryptData = base64_encode($cryptData);

    // Return the encrypted, joined and base64 encode data string.
    return $base64CryptData;
}

function error($msg) {
    doLog($msg);
    header("HTTP/1.0 500 Server error: $msg");
    exit();
}

function doLog($msg) {
    global $ICGPOA_LOG, $ICGPOA_AS_ID;

    $emsg = @date("d-M-Y H:i:s") . ", " . $asId . ": " . $msg . "\n";
    if ($ICGPOA_LOG == "") {
        error_log($emsg);
    }
    else if ($ICGPOA_LOG != "/dev/null") {
            error_log($emsg, 3, $ICGPOA_LOG);
        }
}

?>